The people of Mohammadpur have decided to paint each of their houses red, green, or blue. They've also decided that no two neighboring houses will be painted the same color. The neighbors of house i are houses i-1 and i+1. The first and last houses are not neighbors.

You will be given the information of houses. Each house will contain three integers "R G B"(quotes for clarity only), where R, G and B are the costs of painting the corresponding house red, green, and blue, respectively. Return the minimal total cost required to perform the work.

Input

Input starts with an integer T (≤ 100), denoting the number of test cases.

Each case begins with a blank line and an integer n (1 ≤ n ≤ 20) denoting the number of houses. Each of the next n lines will contain 3 integers "R G B". These integers will lie in the range [1, 1000].

Output

For each case of input you have to print the case number and the minimal cost.

Sample Input

2

4

13 23 12

77 36 64

44 89 76

31 78 45

3

26 40 83

49 60 57

13 89 99

Sample Output

Case 1: 137

Case 2: 96

题解:这个题我一开始想的是每次都找最小的的那一个(除了第一个),并且颜色不相同,这时候开个标记数组,把每次可以涂得选一个较小的,这种解法有很大的问题,既然你考虑了第一个可能不是最小的那后边也可能不是最小的相加就是和最小的,因为你所致的最小是去除不能标记点的最小。而不是单纯每次求最小,和就是最小,是受前边影响的,那我们要求的是和最小,我们就可以每次找和最小的,这样最后找出来肯定是最小的。

附上两次的代码:

错误代码:

#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm> using namespace std; int main()
{
int n;
int a[1005][3];
int mark[1005][3];
scanf("%d",&n);
for(int t=0;t<n;t++)
{
memset(mark,0,sizeof(mark));
int m;
scanf("%d",&m);
for(int j=0;j<m;j++)
{
for(int k=0;k<3;k++)
{
scanf("%d",&a[j][k]);
}
}
long long sum1=a[0][0];
memset(mark,0,sizeof(mark));
mark[0][0]=1;
int temp1; for(int j=1;j<m;j++)
{
int minn=9999;
for(int k=0;k<3;k++)
{
if(!mark[j-1][k])
{
if(minn>a[j][k])
{
minn=a[j][k];
temp1=k;
}
} }
sum1+=minn;
mark[j][temp1]=1; }
long long sum2=a[0][1];
memset(mark,0,sizeof(mark));
mark[0][1]=1;
int temp2; for(int j=1;j<m;j++)
{
int minn=9999;
for(int k=0;k<3;k++)
{
if(!mark[j-1][k])
{
if(minn>a[j][k])
{
minn=a[j][k];
temp2=k;
}
} }
sum2+=minn;
mark[j][temp2]=1; }
long long sum3=a[0][2];
memset(mark,0,sizeof(mark));
mark[0][2]=1;
int temp3; for(int j=1;j<m;j++)
{
int minn=9999;
for(int k=0;k<3;k++)
{
if(!mark[j-1][k])
{
if(minn>a[j][k])
{
minn=a[j][k];
temp3=k;
}
} }
sum3+=minn;
mark[j][temp3]=1; }
if(min(sum1,sum2)>sum3)
{
printf("Case %d: %lld\n",t+1,sum3);
}
else
{
printf("Case %d: %lld\n",t+1,min(sum1,sum2));
}
} return 0;
}

AC代码:

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream> using namespace std; int main()
{
int a[1005][3];
int sum[1005][3];
int n;
scanf("%d",&n);
for(int t=1;t<=n;t++)
{
int m;
scanf("%d",&m);
for(int j=0;j<m;j++)
{
for(int k=0;k<3;k++)
{
scanf("%d",&a[j][k]);
}
}
memset(sum,0,sizeof(sum));
sum[0][0]=a[0][0];
sum[0][1]=a[0][1];
sum[0][2]=a[0][2];
for(int j=1;j<m;j++)
{
sum[j][0]=min(sum[j-1][1],sum[j-1][2])+a[j][0];
sum[j][1]=min(sum[j-1][0],sum[j-1][2])+a[j][1];
sum[j][2]=min(sum[j-1][0],sum[j-1][1])+a[j][2];
}
printf("Case %d: %d\n",t,(min(sum[m-1][0],sum[m-1][1])<sum[m-1][2])?min(sum[m-1][0],sum[m-1][1]):sum[m-1][2]);
} return 0;
}

light oj 1047 - Neighbor House(贪心)的更多相关文章

  1. light oj 1047 - Neighbor House 动态规划

    题目链接:http://acm.hust.edu.cn/vjudge/contest/view.action?cid=87730#problem/C 题目: Description The peopl ...

  2. Light OJ 1114 Easily Readable 字典树

    题目来源:Light OJ 1114 Easily Readable 题意:求一个句子有多少种组成方案 仅仅要满足每一个单词的首尾字符一样 中间顺序能够变化 思路:每一个单词除了首尾 中间的字符排序 ...

  3. lightOJ 1047 Neighbor House (DP)

    lightOJ 1047   Neighbor House (DP) 题目链接:http://acm.hust.edu.cn/vjudge/contest/view.action?cid=87730# ...

  4. Light OJ 1429 Assassin`s Creed (II) BFS+缩点+最小路径覆盖

    题目来源:Light OJ 1429 Assassin`s Creed (II) 题意:最少几个人走全然图 能够反复走 有向图 思路:假设是DAG图而且每一个点不能反复走 那么就是裸的最小路径覆盖 如 ...

  5. Light OJ 1406 Assassin`s Creed 减少国家DP+支撑点甚至通缩+最小路径覆盖

    标题来源:problem=1406">Light OJ 1406 Assassin`s Creed 意甲冠军:向图 派出最少的人经过全部的城市 而且每一个人不能走别人走过的地方 思路: ...

  6. Light OJ 1316 A Wedding Party 最短路+状态压缩DP

    题目来源:Light OJ 1316 1316 - A Wedding Party 题意:和HDU 4284 差点儿相同 有一些商店 从起点到终点在走过尽量多商店的情况下求最短路 思路:首先预处理每两 ...

  7. light oj 1007 Mathematically Hard (欧拉函数)

    题目地址:light oj 1007 第一发欧拉函数. 欧拉函数重要性质: 设a为N的质因数.若(N % a == 0 && (N / a) % a == 0) 则有E(N)=E(N ...

  8. Light OJ 1406 Assassin`s Creed 状态压缩DP+强连通缩点+最小路径覆盖

    题目来源:Light OJ 1406 Assassin`s Creed 题意:有向图 派出最少的人经过全部的城市 而且每一个人不能走别人走过的地方 思路:最少的的人能够走全然图 明显是最小路径覆盖问题 ...

  9. Light OJ 1288 Subsets Forming Perfect Squares 高斯消元求矩阵的秩

    题目来源:Light OJ 1288 Subsets Forming Perfect Squares 题意:给你n个数 选出一些数 他们的乘积是全然平方数 求有多少种方案 思路:每一个数分解因子 每隔 ...

随机推荐

  1. ssh框架搭建实例代码教程步骤

    http://blog.csdn.net/u010539352/article/details/49255729

  2. Angular07 利用angular打造管理系统页面

    1 创建一个新的angular应用 ng new adminSystem 2 利用WebStorm打开adminSystem应用 3 借助AdminLTE这个开源项目来辅助开发 AdminLTE项目: ...

  3. noi.ac day6t1 queen

    传送门 分析 我就是个BT...... 直接排序后开数组记录每条线上的信息,注意由于每个点只会影响前面第一个点和后面第一个点,所以记录每条线的前一个点就行了. 代码 #include<iostr ...

  4. sed编辑器使用(转)

    1.Sed简介 sed 是一种在线编辑器,它一次处理一行内容.处理时,把当前处理的行存储在临时缓冲区中,称为“模式空间”(pattern space),接着用sed命令处理缓冲区中的内容,处理完成后, ...

  5. PersonDto中@ResourceAccess(readOnly = true)以及swagger的理解-----似懂非懂,日后消化

    @JsonApiResource(type = PersonDto.RESOURCE_TYPE) @EntityMapping(entityClass = Person.class) //@Resou ...

  6. HDU 1796 How many integers can you find (容斥)

    题意:给定一个数 n,和一个集合 m,问你小于的 n的所有正数能整除 m的任意一个的数目. 析:简单容斥,就是 1 个数的倍数 - 2个数的最小公倍数 + 3个数的最小公倍数 + ...(-1)^(n ...

  7. sql 简单的定义变量 声明 输出

    --定义变量 声明 变量名 数据类型 varchar默认长度为1 --char 当字符不够时 用空格代替 declare @a char(10) --字符串用单引号 set @a ='abcdef' ...

  8. 未能加载文件或程序集“Interop.SQLDMO”或它的某一个依赖项

    程序运行没问题,当您配置好IIS后,打开安装向导时出现以下错误信息: 解决办法为:在IIS应用程序池中“启用32位应用程序”, 1,打开IIS应用程序池,选中相应应用程序池,点击右侧“高级设置” 2, ...

  9. c#打开关闭进程

    private const string FileName = "test.exe"; //进程名称不带扩展名 private const string ProcessName = ...

  10. 【C# MVC】

    http://www.cnblogs.com/powertoolsteam/p/MVC_three.html